-----------------------------------------------------------
------------ Point Blank by Joni And Friends --------------
-----------------------------------------------------------
-----------------------------------------------------------


function initArray(m)
      local array = {}
         for i = 1, m do
           array[i]=0
         end
      return array
end

function totable(t,match)
	local cmd = {}
	if not match then match = "[^%s]+" end
	for word in string.gmatch(t, match) do
		table.insert(cmd, word)
	end 
	return cmd 
end
------------------------------------------------

---======= info =======---
-- hudtxt used = 2 --- last for vote map

---======= Settings =======---
pb_locgfx="gfx/JAF/PointBlank/"
pb_locsfx="JAF/PointBlank/"
pb_loclua="sys/lua/JAF-PointBlank/"
parse("mp_hud 127")
parse("mp_startmoney 16000")
parse("mp_idleaction 4")
parse("mp_dmspawnmoney 0")
parse("sv_maxplayers 32")
parse("mp_teamkillpenalty 0")
parse("mp_autoteambalance 1")
parse("sv_friendlyfire 0")
parse("mp_infammo 0")
------color------- Indonesian language
putih = "255255255"
hitam = "000000000"
hijau = "000555000"
hijau2 = "0  128  0"
merah = "255000000"
abu = "191191191"
emas = "255215000"
biru = "30 144255"
biru2 = "0  0  255"
coklat = "15075   0"
ungu = "191  0255"
kuning = "255255  0"
nila = "111  0255"
oren = "255127  0"
ungu2 = "128  0128"
violet = "233130238"
coklat2 = "160 82 45"
cyan = "000255255"
------end--------
pival = math.pi / 180
extraarmored = 12
extranoarmored = 25
killIMG_max=9

---======= Table's =======---
admin_stat={putih,"[STAFF]","[GM]","[Developer]"}
pb_maplist={}
cmd={
     {cmd="rs",
      admin=0,
      action=function(id,txt)
      parse("setscore "..id.." 0")
      parse("setdeaths "..id.." 0")
      msg2(id,"[Server] "..hijau.."Score/death reseted!")
      msg("[Server] "..hijau..""..player(id,"name").." has reset his score/deaths")
end};
}
      



---======= Arrays =======---
pb_point=initArray(32)
jaf_cash=initArray(32)
pb_usgn=initArray(32)
pb_kill_effect=initArray(32)
pb_kills=initArray(32)
pb_admin=initArray(32)
pb_level=initArray(32)
pb_exp=initArray(32)
pb_maskilldetect=initArray(32)
killIMG=initArray(32)
pb_headshot=initArray(32)
killSIMG=initArray(32)
pb_vote=initArray(32)
pb_baretIMG=initArray(32)

---======= Functions =======---
function pb_reset(id)
        pb_point[id]=0
        pb_usgn[id]=0
        pb_kill_effect[id]=1
        pb_kills[id]=0
        pb_admin[id]=0
        pb_level[id]=1
        pb_exp[id]=0
        pb_maskilldetect[id]=0
        killIMG[id]={}
        for g=1,killIMG_max do
           killIMG[id][g]=nil
        end
        killSIMG[id]=nil
        pb_headshot[id]=0
        pb_vote[id]=0
        pb_baretIMG[id]=nil
end

function pb_CheckAdmin(usgn)
	local filename = pb_loclua.."admin.txt"
	local file = io.open(filename)
	if file then
		for line in file:lines() do
			local parses = totable(line)
			if tonumber(parses[1]) ~= nil then
				if usgn==tonumber(parses[1]) then
					if tonumber(parses[2]) ~= nil then
						return tonumber(parses[2])
					else
						return 1
					end
				end
			end
		end
		if file ~= nil then
			file:close()
		end
	end		
	return 0
end

function pb_save(id,UsgnID)
if UsgnID>0 then
	file = io.output(io.open(pb_loclua.."user/"..UsgnID..".txt","w+"))
	local text = ""
	text = tostring(pb_point[id])
	text = text .." "..pb_kill_effect[id]
	text = text .." "..pb_level[id]
	text = text .." "..pb_exp[id]

	file:write(text)
	file:close()
end
end

function pb_load(id,UsgnID)
pb_admin[id] = pb_CheckAdmin(UsgnID)
local filename = pb_loclua.."user/%s.txt"
if UsgnID~=0 then
local file = io.open(filename:format(UsgnID,"r"))
if file then
	line = file:read()
	local parses = totable(line)
	local w1=tonumber(parses[1])
	local w2=tonumber(parses[2])
	local w3=tonumber(parses[3])
	local w4=tonumber(parses[4])
	if w1~=nil then pb_point[id]=w1 end
	if w2~=nil then pb_kill_effect[id]=w2 end
	if w3~=nil then pb_level[id]=w3 end
	if w4~=nil then pb_exp[id]=w4 end
        msg2(id,"[Server] "..hijau.."Your data has been loaded!")
        else
        msg2(id,"[Server] "..merah.."Your data not founded then server created your data!")
        pb_save(id,UsgnID)
	end
end
if pb_admin[id]>0 then
       msg2(id,"[Server] "..hijau.."Welcome admin!")
end
if pb_admin[id]>#admin_stat-1 then
      pb_admin[id]=#admin_stat-1
end
if pb_usgn[id]>0 then
       msg2(id,"[Server] "..hijau.."Thank you for login, we hope you like our server.")
end
       msg("[Server] "..hijau.."Welcome "..player(id,"name").." Joining to "..biru..""..game("sv_name").."!")
end

function pb_point_plus(id,p,_msgpb,_msg2pb)
          pb_point[id]=pb_point[id]+p
          if _msgpb~=nil then
               msg(_msgpb)
          end
          if _msg2pb~=nil then
               msg2(id,_msg2pb)
          end
end

function correctrot(angle)
	if (angle>90 and angle<=180) then
		return angle - 270
	 else
		return angle + 90
	end
end

function toradians(angle)
	return pival*angle
end

function calcdis(a,b)
	local ax = player(a,"tilex")
	local ay = player(a,"tiley")
	local bx = player(b,"tilex")
	local by = player(b,"tiley")
	return math.floor(math.sqrt((bx-ax)^2 + (by-ay)^2))
end

function hskill(victim,killer)
pb_headshot[killer]=pb_headshot[killer]+1
pb_exp[killer]=pb_exp[killer]+200
if pb_maskilldetect[killer]<2 then
           parse("customkill "..killer.." Head "..victim)
           if pb_maskilldetect[killer]<2 then
           kills_set(killer,"headkill.png")
           pb_point_plus(killer,150)
           parse('sv_sound2 '..killer..' "'..pb_locsfx..'headshot.ogg"')
           elseif pb_maskilldetect[killer]>1 then
           kills_set(killer,"piercingshot.png")
           pb_point_plus(killer,250)
           end
end
end

function pb_knife_check(wpn)
      	if (wpn == 50) or (wpn == 69) or (wpn == 74) or (wpn == 78) or (wpn == 85) then
		return true
	else
		return false
	end
end

function kill_set(id,img)
    for g=1,killIMG_max do
        if killIMG[id][g]==nil then
             killIMG[id][g]=image(pb_locgfx..""..img,20+((g-1)*32),420,2,id)
             return 1
        end
    end
end

function freeimagekill(id)
         for g=1,killIMG_max do
               if killIMG[id][g]~=nil then
                    freeimage(killIMG[id][g])
                    killIMG[id][g]=nil
                end
          end
end

function freeimagekills(id)
               if killSIMG[id]~=nil then
                    freeimage(killSIMG[id])
                    killSIMG[id]=nil
                end
end

function kills_set(id,img)
freeimagekills(id)
        if killSIMG[id]==nil then
             killSIMG[id]=image(pb_locgfx..""..img,320,130,2,id)
             tween_alpha(killSIMG[id],2000,0)
        end
end

function pb_checkmaplist()
pb_maplist={}
	local filename = pb_loclua.."maplist.txt"
	local file = io.open(filename)
        b=0
	if file then
		for line in file:lines() do
				if line~=nil then
                                     b=b+1
                                     pb_maplist[b]=line
				end
		end
		if file ~= nil then
			file:close()
		end
	end		
	return b
end
pb_checkmaplist()

function pb_checkalivepl()
tero,ct=player(0,"team1living"),player(0,"team2living")
      if #tero==1 then
             msg("[Server] "..putih..""..player(tero[1],"name").." is the last player on Tero!")
   end
      if #ct==1 then
             msg("[Server] "..putih..""..player(ct[1],"name").." is the last player on CT!")
   end
      if #tero==1 and #ct==1 then
              msg("[Server] "..putih..""..player(tero[1],"name").." Vs "..player(ct[1],"name"))
   end
end

function freeimagebaret(id)
      if pb_baretIMG[id]~=nil then
            freeimage(pb_baretIMG[id])
            pb_baretIMG[id]=nil
      end
end

function pb_baretset(id)
freeimagebaret(id)
pb_baretIMG[id]=image(pb_locgfx.."baret.png",1,0,200+id)
end
      